import * as React from 'react';
import type { SharedPickerProps, ValueDate } from '../../interface';
import { type FooterProps } from './Footer';
import { type PopupPanelProps } from './PopupPanel';
export interface PopupProps<DateType extends object = any, PresetValue = DateType> extends Pick<React.InputHTMLAttributes<HTMLDivElement>, 'onFocus' | 'onBlur'>, FooterProps<DateType>, PopupPanelProps<DateType> {
    panelRender?: SharedPickerProps['panelRender'];
    presets: ValueDate<DateType>[];
    onPresetHover: (presetValue: PresetValue) => void;
    onPresetSubmit: (presetValue: PresetValue) => void;
    activeOffset?: number;
    direction?: 'ltr' | 'rtl';
    needConfirm: boolean;
    isInvalid: (date: DateType | DateType[]) => boolean;
}
export default function Popup<DateType extends object = any>(props: PopupProps<DateType>): React.JSX.Element;
