import * as React from 'react';
import { PickerHackContext, usePanelContext } from "./context";
var HIDDEN_STYLE = {
  visibility: 'hidden'
};
function PanelHeader(props) {
  var onOffset = props.onOffset,
    onSuperOffset = props.onSuperOffset,
    children = props.children;
  var _usePanelContext = usePanelContext(),
    prefixCls = _usePanelContext.prefixCls,
    _usePanelContext$prev = _usePanelContext.prevIcon,
    prevIcon = _usePanelContext$prev === void 0 ? "\u2039" : _usePanelContext$prev,
    _usePanelContext$next = _usePanelContext.nextIcon,
    nextIcon = _usePanelContext$next === void 0 ? "\u203A" : _usePanelContext$next,
    _usePanelContext$supe = _usePanelContext.superPrevIcon,
    superPrevIcon = _usePanelContext$supe === void 0 ? "\xAB" : _usePanelContext$supe,
    _usePanelContext$supe2 = _usePanelContext.superNextIcon,
    superNextIcon = _usePanelContext$supe2 === void 0 ? "\xBB" : _usePanelContext$supe2;
  var headerPrefixCls = "".concat(prefixCls, "-header");
  var _React$useContext = React.useContext(PickerHackContext),
    hidePrev = _React$useContext.hidePrev,
    hideNext = _React$useContext.hideNext;
  return /*#__PURE__*/React.createElement("div", {
    className: headerPrefixCls
  }, onSuperOffset && /*#__PURE__*/React.createElement("button", {
    type: "button",
    onClick: function onClick() {
      return onSuperOffset(-1);
    },
    tabIndex: -1,
    className: "".concat(headerPrefixCls, "-super-prev-btn"),
    style: hidePrev ? HIDDEN_STYLE : {}
  }, superPrevIcon), onOffset && /*#__PURE__*/React.createElement("button", {
    type: "button",
    onClick: function onClick() {
      return onOffset(-1);
    },
    tabIndex: -1,
    className: "".concat(headerPrefixCls, "-prev-btn"),
    style: hidePrev ? HIDDEN_STYLE : {}
  }, prevIcon), /*#__PURE__*/React.createElement("div", {
    className: "".concat(headerPrefixCls, "-view")
  }, children), onOffset && /*#__PURE__*/React.createElement("button", {
    type: "button",
    onClick: function onClick() {
      return onOffset(1);
    },
    tabIndex: -1,
    className: "".concat(headerPrefixCls, "-next-btn"),
    style: hideNext ? HIDDEN_STYLE : {}
  }, nextIcon), onSuperOffset && /*#__PURE__*/React.createElement("button", {
    type: "button",
    onClick: function onClick() {
      return onSuperOffset(1);
    },
    tabIndex: -1,
    className: "".concat(headerPrefixCls, "-super-next-btn"),
    style: hideNext ? HIDDEN_STYLE : {}
  }, superNextIcon));
}
export default PanelHeader;