"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getTimeConfig = getTimeConfig;
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));
var _miscUtil = require("../utils/miscUtil");
var showTimeKeys = ['format', 'showNow', 'showHour', 'showMinute', 'showSecond', 'showMillisecond', 'use12Hours', 'hourStep', 'minuteStep', 'secondStep', 'millisecondStep', 'hideDisabledOptions', 'defaultValue', 'disabledHours', 'disabledMinutes', 'disabledSeconds', 'disabledMilliseconds', 'disabledTime', 'changeOnScroll'];

/**
 * Get SharedTimeProps from props.
 */
function pickTimeProps(props) {
  var timeProps = (0, _miscUtil.pickProps)(props, showTimeKeys);
  if (timeProps.format) {
    var format = timeProps.format;
    if (Array.isArray(format)) {
      format = format[0];
    }
    timeProps.format = (0, _typeof2.default)(format) === 'object' ? format.format : format;
  }
  return timeProps;
}
function getTimeConfig() {
  var componentProps = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var showTime = componentProps.showTime,
    picker = componentProps.picker;
  if (showTime || picker === 'time') {
    var timeConfig = showTime && (0, _typeof2.default)(showTime) === 'object' ? showTime : pickTimeProps(componentProps);
    return (0, _objectSpread2.default)({
      format: 'HH:mm:ss'
    }, (0, _miscUtil.pickProps)(timeConfig));
  }
  return null;
}